#pragma implementation
#include <dlfcn.h>
#include "libmodules.h"
#include <string.h>

LIBMODULE::LIBMODULE(char *name)
{
	char *module_template = "/usr/lib/linuxconf/libmodules/lib%s.so";
	char *module_path = (char *) malloc(strlen(module_template)+strlen(name)-1);
	sprintf(module_path,module_template,name);
	handle = dlopen(module_path,RTLD_LAZY|RTLD_GLOBAL);
	free(module_path);
}

LIBMODULE::~LIBMODULE()
{
	if (handle != NULL)
		dlclose(handle);
}

bool LIBMODULE::loaded()
{
	return (handle != NULL);
}

// Just to force the linkage
void libmodules_required()
{
}

// vim:nowrap
